_G.AVF = _G.AVF or {}
AVF._path = ModPath
AVF.settings_path = SavePath .. "vehicle_fov.txt"

function AVF:Reset()
	self.settings = {
		avf_fov = 90,
		avf_vw_typ_82_dist = -400,
		avf_vw_typ_82_height = 200,
		avf_opel_blitz_dist = -700,
		avf_opel_blitz_height = 300,
		avf_tpc = false
	}
end

function AVF:Save()
	local file = io.open( self.settings_path, "w+" )
	if file then
		file:write( json.encode( self.settings ) )
		file:close()
	end
end

function AVF:Load()
	local file = io.open( self.settings_path, "r" )
	if file then
		self.settings = json.decode( file:read("*all") )
		file:close()
	else
		AVF:Reset()
		AVF:Save()
	end
end

AVF:Load()

if RequiredScript == "lib/tweak_data/vehicletweakdata" then
	local old_init = VehicleTweakData.init

	function VehicleTweakData:init(tweak_data)
		old_init(self, tweak_data)

		self.kubelwagen.seats.driver.fov = AVF.settings.avf_fov
		self.truck.seats.driver.fov = AVF.settings.avf_fov
		
		if AVF.settings.avf_tpc == true then
			self.kubelwagen.driver_camera_offset = Vector3(0,  AVF.settings.avf_vw_typ_82_dist,  AVF.settings.avf_vw_typ_82_height)
			self.truck.driver_camera_offset = Vector3(0,  AVF.settings.avf_opel_blitz_dist,  AVF.settings.avf_opel_blitz_height)
		end

	end
end