AVFMenu = AVFMenu or class(BLTMenu)

function AVFMenu:Init(root)
	self:Title({
		text = "avf_options_menu_title",
	})
	self:Label({
		text = nil,
		localize = false,
		h = 8,
	})
	self:Slider({
		name = "avf_options_menu_title",
		text = "avf_options_menu_title",
		value_format = "%d",
		value = AVF.settings.avf_fov,
		min = 75,
		max = 150,
		callback = callback(self, self, "AVFSetCustomFOV"),
	})
	self:Toggle({
        name = "avf_options_tpc_title",
        text = "avf_options_tpc_title",
        value = AVF.settings.avf_tpc,
        callback = callback(self, self, "AVFSetThirdPerson"),
    })
	self:LongRoundedButton2({
		name = "avf_options_reset",
		text = "avf_options_reset",
		localize = true,
		callback = callback(self, self, "Reset"),
		ignore_align = true,
		y = 832,
		x = 1472,
	})
	self:Slider({
		name = "avf_options_vw_typ_82_dist_title",
		text = "avf_options_vw_typ_82_dist_title",
		value_format = "%d",
		value = -1 * AVF.settings.avf_vw_typ_82_dist,
		min = 200,
		max = 800,
		callback = callback(self, self, "AVFSetCustomTyp82Dist"),
	})
	self:Slider({
		name = "avf_options_vw_typ_82_height_title",
		text = "avf_options_vw_typ_82_height_title",
		value_format = "%d",
		value = AVF.settings.avf_vw_typ_82_height,
		min = 100,
		max = 400,
		callback = callback(self, self, "AVFSetCustomTyp82Height"),
	})
	self:Slider({
		name = "avf_options_opel_blitz_dist_title",
		text = "avf_options_opel_blitz_dist_title",
		value_format = "%d",
		value = -1 * AVF.settings.avf_opel_blitz_dist,
		min = 400,
		max = 1000,
		callback = callback(self, self, "AVFSetCustomBlitzDist"),
	})
	self:Slider({
		name = "avf_options_opel_blitz_height_title",
		text = "avf_options_opel_blitz_height_title",
		value_format = "%d",
		value = AVF.settings.avf_opel_blitz_height,
		min = 100,
		max = 500,
		callback = callback(self, self, "AVFSetCustomBlitzHeight"),
	})
end

function AVFMenu:AVFSetCustomFOV(value, item)
	AVF.settings.avf_fov = tonumber(value)
	self._needs_save = true
end

function AVFMenu:AVFSetThirdPerson(value, item)
	AVF.settings.avf_tpc = value
	self._needs_save = true
end

function AVFMenu:AVFSetCustomTyp82Dist(value, item)
	AVF.settings.avf_vw_typ_82_dist = -1 * tonumber(value)
	self._needs_save = true
end

function AVFMenu:AVFSetCustomTyp82Height(value, item)
	AVF.settings.avf_vw_typ_82_height = tonumber(value)
	self._needs_save = true
end

function AVFMenu:AVFSetCustomBlitzDist(value, item)
	AVF.settings.avf_opel_blitz_dist = -1 * tonumber(value)
	self._needs_save = true
end

function AVFMenu:AVFSetCustomBlitzHeight(value, item)
	AVF.settings.avf_opel_blitz_height = tonumber(value)
	self._needs_save = true
end

function AVFMenu:Reset(value, item)
	QuickMenu:new(
		managers.localization:text("avf_options_reset"),
		managers.localization:text("avf_options_reset_confirm"),
		{
			[1] = {
				text = managers.localization:text("dialog_no"),
				is_cancel_button = true,
			},
			[2] = {
				text = managers.localization:text("dialog_yes"),
				callback = function()
					AVF:Reset(true)
					self._needs_save = true
					self:ReloadMenu()
				end,
			},
		},
		true
	)
end

function AVFMenu:Close()
	if self._needs_save then
		AVF:Save()
	end
end

Hooks:Add("MenuComponentManagerInitialize", "AVFMenu.MenuComponentManagerInitialize", function(self)
	RaidMenuHelper:CreateMenu({
		name = "avf_options_menu",
		name_id = "avf_options_menu_title",
		inject_menu = "blt_options",
		class = AVFMenu
	})
end)
